Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.cpp	(revision 1959)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.cpp	(revision 1960)
@@ -12,5 +12,5 @@
   }
   
-  CGridLocalConnector* CGridLocalElements::getConnector(CElementView::type srcType, CElementView::type dstType)
+  CGridLocalConnector* CGridLocalElements::getConnector(CElementView::type srcType, CElementView::type dstType, bool withMask)
   {
     auto newPair = pair<CElementView::type,CElementView::type>(srcType,dstType);
@@ -18,5 +18,5 @@
     if (it==connectors_.end()) 
     {
-      auto insertPair=pair<pair<CElementView::type,CElementView::type>, CGridLocalConnector*>(newPair,new CGridLocalConnector(this, srcType, dstType)) ;
+      auto insertPair=pair<pair<CElementView::type,CElementView::type>, CGridLocalConnector*>(newPair,new CGridLocalConnector(this, srcType, dstType, withMask)) ;
       it=connectors_.insert(insertPair).first ;
     }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.hpp	(revision 1959)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_elements.hpp	(revision 1960)
@@ -28,5 +28,5 @@
       std::vector<CLocalElement*>& getElements(void) { return elements_ ; }
       CGridLocalView* getView(CElementView::type type) ;
-      CGridLocalConnector* getConnector(CElementView::type srcType, CElementView::type dstType) ;
+      CGridLocalConnector* getConnector(CElementView::type srcType, CElementView::type dstType, bool withMask=false) ;
   } ;
 }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.cpp	(revision 1959)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.cpp	(revision 1960)
@@ -16,5 +16,5 @@
   } 
 
-  CGridLocalConnector::CGridLocalConnector(CGridLocalElements* parent, CElementView::type srcType, CElementView::type dstType)
+  CGridLocalConnector::CGridLocalConnector(CGridLocalElements* parent, CElementView::type srcType, CElementView::type dstType, bool withMask)
   {
     CGridLocalView* srcView=parent->getView(srcType) ;
@@ -31,5 +31,5 @@
     for(auto connector : elementsConnector_) dstSize_*=connector->getDstSize() ;
 
-    if (parent->hasLocalMask())
+    if (parent->hasLocalMask() && withMask)
     {
       vector<CLocalConnector*> elementsConnector ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.hpp	(revision 1959)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/distribution/grid_local_connector.hpp	(revision 1960)
@@ -25,5 +25,5 @@
       
       CGridLocalConnector(const std::vector<CLocalConnector*>& elementsConnector)  ;
-      CGridLocalConnector(CGridLocalElements* parent, CElementView::type srcType, CElementView::type dstType) ;
+      CGridLocalConnector(CGridLocalElements* parent, CElementView::type srcType, CElementView::type dstType, bool withMask=false) ;
       int getSrcSize(void) { return srcSize_ ;}
       int getDstSize(void) { return dstSize_ ;}
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1959)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1960)
@@ -3388,5 +3388,5 @@
   void CGrid::computeModelToWorkflowConnector(void)
   {
-    modelToWorkflowConnector_ = getGridLocalElements()->getConnector(CElementView::MODEL,CElementView::WORKFLOW) ;
+    modelToWorkflowConnector_ = getGridLocalElements()->getConnector(CElementView::MODEL,CElementView::WORKFLOW,true) ;
   }
 
@@ -3398,5 +3398,5 @@
   void CGrid::computeWorkflowToModelConnector(void)
   {
-    workflowToModelConnector_ = getGridLocalElements()->getConnector(CElementView::WORKFLOW,CElementView::MODEL) ;
+    workflowToModelConnector_ = getGridLocalElements()->getConnector(CElementView::WORKFLOW,CElementView::MODEL,true) ;
   }
 